<?php
# Copyright (C) 2004 Tuatha de Dana

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# Function to fill an array
function array_fill($iStart, $iLen, $vValue) {
   $aResult = array();
   for ($iCount = $iStart; $iCount < $iLen + $iStart; $iCount++) {
       $aResult[$iCount] = $vValue;
   }
   return $aResult;
}

function build_row_display($array_display_rows) {
   # Build the rows to display from the array "array_display_rows"
   $count_display_rows = count($array_display_rows);
   for ($array_counter=0;$array_counter<$count_display_rows;$array_counter++) {
      if ( $array_counter == 0 ) {
         $sql_display_rows=$array_display_rows[$array_counter];
      } else {
         $sql_display_rows=$sql_display_rows . ", " . $array_display_rows[$array_counter];
      }
   }
   return $sql_display_rows;
}

function get_variables ()
{
   ob_start();
   require('db.inc');
   $str = ob_get_contents();
   ob_end_clean();
}

include_once 'functions.inc';
make_header();
print "<BR>\n<CENTER>\n";
print "<FONT COLOR=\"blue\">\n<CENTER>\n";
print "Please note that new data is imported every 5 minutes. This is not a real-time display\n";
print "</FONT>\n<BR>\n</CENTER>\n";

# Variables derived from the calling page.
$limit_num=$HTTP_POST_VARS['req_results'];
$query_host=$HTTP_POST_VARS['req_host'];
$query_facility=$HTTP_POST_VARS['req_facility'];
$query_priority=$HTTP_POST_VARS['req_priority'];
$query_program=$HTTP_POST_VARS['req_program'];
$query_sort=$HTTP_POST_VARS['req_sort'];
$limit_date=$HTTP_POST_VARS['req_date'];
$custom_date=$HTTP_POST_VARS['req_cust_date'];
$custom_incl_msg=$HTTP_POST_VARS['req_cust_text'];
$custom_excl_msg=$HTTP_POST_VARS['req_cust_excl'];
$custom_which_words=$HTTP_POST_VARS['req_options'];

# Check query date
get_variables();
$sql_display_rows=build_row_display($array_display_rows);

# Create SQL string for the LIMIT value.
if ( $limit_num  > 0 ) {
   $query_limit="LIMIT $limit_num";
} else {
   $query_limit="";
}

# Create SQL string for the date part.
if ( $limit_date == "TODAY" ) {
   $query_date="AND date = CURDATE() ";
} else {
   $query_date="AND date >= CURDATE() - INTERVAL $limit_date ";
} 

if ( $limit_date == "0" ) {
   $query_date="";
}

# Create SQL string for the text search part.
if ( $custom_date != "" ) {
   $query_date="AND date = \"$custom_date\"";
} 

# If the "exact phrase" is required, the complete phrase should be found.

if ( $custom_excl_msg != "" && $custom_which_words == "exact_phrase" ) {
   $sql_excl_stat ="AND msg NOT LIKE \"%$custom_excl_msg%\"";
} elseif ( $custom_excl_msg != "" && $custom_which_words == "any_words" ) {
   $custom_exclude_msg_array = split(" ", $custom_excl_msg);
   $excl_counter = count($custom_exclude_msg_array);
   $array_counter=0;
   while ($array_counter < $excl_counter) {
      if ($array_counter == 0) {
         $query_excl_array[$array_counter]="AND msg NOT LIKE \"%$custom_exclude_msg_array[$array_counter]%\"";
      } else {
         $query_excl_array[$array_counter]="AND msg NOT LIKE \"%$custom_exclude_msg_array[$array_counter]%\"";
      }
      $array_counter++;
   }
   foreach ($query_excl_array as $excl_array_value ) {
      $sql_excl_stat = $sql_excl_stat . " " . $excl_array_value;
   }
}

if ( $custom_incl_msg != "" && $custom_which_words == "exact_phrase" ) {
   $sql_incl_stat = "AND msg LIKE \"%$custom_incl_msg%\"";
} elseif ( $custom_incl_msg != "" && $custom_which_words == "any_words" ) {
   $custom_include_msg_array = split(" ", $custom_incl_msg);
   $incl_counter = count($custom_include_msg_array);
   $array_counter=0;
   while ($array_counter < $incl_counter) { 
      if ($array_counter == 0) {
         $query_incl_array[$array_counter]="AND msg LIKE \"%$custom_include_msg_array[$array_counter]%\"";
      } else {
         $query_incl_array[$array_counter]="OR msg LIKE \"%$custom_include_msg_array[$array_counter]%\"";
      }
      $array_counter++;
   }
   foreach ($query_incl_array as $incl_array_value ) {
      $sql_incl_stat = $sql_incl_stat . " " . $incl_array_value;
   }
}

# Create and print HTML headers
get_variables();

print "<HTML>\n";
print "<TITLE>$header_common - $header_title</TITLE>\n";
print "<HEAD>\n";
print "<STYLE TYPE=\"text/css\">\n";
print "<!--\n";
print "IMG { float:left; margin-right: 50px; }\n";
print "-->\n";
print "</STYLE>\n";
print "</HEAD>\n";
print "<BODY>\n";
print "<FORM METHOD=\"post\" ACTION=\"$post_action\">\n";

# Get the info from the database
$db = mysql_connect($sqlhost,$sqluser,$sqlpass);
@mysql_select_db($database,$db) or die(mysql_errno());

$sql_nu_rows_select="SELECT COUNT(*) FROM $table";
$sql_rows_select="SELECT $sql_display_rows FROM $table";

$sql_begin_stat="WHERE host LIKE \"$query_host\"
		AND facility LIKE \"$query_facility\"
		AND priority LIKE \"$query_priority\"
		AND program LIKE \"$query_program\"
		$query_date";

$sql_end_stat=" ORDER BY date $query_sort, time DESC
		$query_limit";

$sql="$sql_rows_select $sql_begin_stat $sql_excl_stat $sql_incl_stat $sql_end_stat";

#print "$sql <BR>";

$result = mysql_query($sql, $db) or die(mysql_error());

# Find out how many rows the query has and report is less are selected.
$sql_nu_rows = mysql_query("$sql_nu_rows_select $sql_statement");
$r = mysql_fetch_row($sql_nu_rows);
$result_num_rows = $r[0];

if ( $result_num_rows > $limit_num && $limit_num != 0 )
{
   print "<FONT COLOR=\"#FF0000\">\n<B>\n<CENTER>\n";
   print "You've requested the results to be limited to $limit_num rows. However, there are $result_num_rows results available. <BR>\n";
   print "Just that you know. I'm not resonsible if you miss something.<BR><BR>\n";
   print "</FONT>\n</CENTER>\n</B>\n";
   print "<hr style=\"width: 100%; height: 2px;\"><BR>\n";
} 

# Send output from database to table
if ( $custom_date != "" ) {
   $year = substr($custom_date,0,4);
   $mnd = substr($custom_date,5,2);
   $day = substr($custom_date,8,2);
} else {
   $year = 2004;
   $mnd = 01;
   $day = 01;
}

# Only send output to the screen if the date is valid.
# Nicer would be to open a special page, but how?
if (checkdate($mnd,$day,$year)) {
   # Create header for table
   print "<TABLE CELLSPACING=\"2\" CELLPADDING=\"2\" BORDER=\"0\">";
   print "<TR STYLE=\"background: blue; color: white;\">\n";
   foreach ($array_display_rows as $value_heading) {
      print "<TD>$value_heading</TD>\n";
   }
   print "</TR>\n";

   while ( $row = mysql_fetch_array($result, MYSQL_ASSOC) ) {
      print "\t<tr>\n";
      foreach ($row as $col_value) {
         echo "\t\t<td>$col_value</td>\n";
      }
      print "\t</tr>\n";
   }
} else {
   # Date is not ok. Set a default one.
   print "<CENTER>\n";
   print "<BR><BR>\n";
   print "Date is not OK. Please return and change the field named <B>\"Show logs for this date:\"</B>.<BR>\n";
   print "<A HREF=\"index.php\">Return to whence you came</A>\n";
   print "</CENTER>\n";
}

print "</table>\n";

mysql_free_result($result);
mysql_close($db);

print "</body>\n";
print "</html>\n";
?>
